package org.dromara.art.service.impl;

import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.dromara.art.domain.bo.ArtSchoolDormBo;
import org.dromara.art.domain.vo.ArtSchoolDormVo;
import org.dromara.art.domain.ArtSchoolDorm;
import org.dromara.art.mapper.ArtSchoolDormMapper;
import org.dromara.art.service.IArtSchoolDormService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 校区宿舍条件Service业务层处理
 *
 * @author ZhouWenTao
 * @date 2026-02-17
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class ArtSchoolDormServiceImpl implements IArtSchoolDormService {

    private final ArtSchoolDormMapper baseMapper;

    /**
     * 查询校区宿舍条件
     *
     * @param dormId 主键
     * @return 校区宿舍条件
     */
    @Override
    public ArtSchoolDormVo queryById(Long dormId){
        return baseMapper.selectVoById(dormId);
    }

    /**
     * 分页查询校区宿舍条件列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 校区宿舍条件分页列表
     */
    @Override
    public TableDataInfo<ArtSchoolDormVo> queryPageList(ArtSchoolDormBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<ArtSchoolDorm> lqw = buildQueryWrapper(bo);
        Page<ArtSchoolDormVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的校区宿舍条件列表
     *
     * @param bo 查询条件
     * @return 校区宿舍条件列表
     */
    @Override
    public List<ArtSchoolDormVo> queryList(ArtSchoolDormBo bo) {
        LambdaQueryWrapper<ArtSchoolDorm> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<ArtSchoolDorm> buildQueryWrapper(ArtSchoolDormBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<ArtSchoolDorm> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(ArtSchoolDorm::getDormId);
        lqw.eq(bo.getCampusId() != null, ArtSchoolDorm::getCampusId, bo.getCampusId());
        lqw.eq(bo.getRoomSize() != null, ArtSchoolDorm::getRoomSize, bo.getRoomSize());
        lqw.eq(bo.getBunkBedDesk() != null, ArtSchoolDorm::getBunkBedDesk, bo.getBunkBedDesk());
        lqw.eq(bo.getPrivateBath() != null, ArtSchoolDorm::getPrivateBath, bo.getPrivateBath());
        lqw.eq(StringUtils.isNotBlank(bo.getTags()), ArtSchoolDorm::getTags, bo.getTags());
        lqw.eq(StringUtils.isNotBlank(bo.getDescription()), ArtSchoolDorm::getDescription, bo.getDescription());
        return lqw;
    }

    /**
     * 新增校区宿舍条件
     *
     * @param bo 校区宿舍条件
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(ArtSchoolDormBo bo) {
        ArtSchoolDorm add = MapstructUtils.convert(bo, ArtSchoolDorm.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setDormId(add.getDormId());
        }
        return flag;
    }

    /**
     * 修改校区宿舍条件
     *
     * @param bo 校区宿舍条件
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(ArtSchoolDormBo bo) {
        ArtSchoolDorm update = MapstructUtils.convert(bo, ArtSchoolDorm.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(ArtSchoolDorm entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除校区宿舍条件信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
